import { JSONAPI } from 'vuejs/api/json-axios'
import { MA } from 'vuejs/api/ma-axios'
import qs from 'querystring'

export default {
  namespaced: true,

  // initial state
  state : {
    keys: "",
    autocomplete: "",
    results: {}
  },

  // getters
  getters : {},

  // mutations
  mutations : {
    setResults (state, data) {
      state.results = data.results
    },
    setKeys (state, keys) {
      state.keys = keys
    },
    setAutocomplete (state, autocomplete) {
      state.autocomplete = autocomplete
    }
  },

  // actions
  actions : {
    getResults ({ dispatch, commit, state }) {
      let params = {
        keys: state.keys,
        autocomplete: state.autocomplete,
        offset:0,
        limit: 25
      }
      console.log('Search getResults params', params);
      let q = qs.stringify(params)
      return MA.get(`/materio_sapi/getresults?`+q)
        .then(({ data }) => {
          console.log('search MA getresults data', data)
          commit('setResults', data)
        })
        .catch(( error ) => {
            console.warn('Issue with getResults', error)
            Promise.reject(error)
        })
    }
  }
}
